/// @cond EO_CXX_EO_IMPL

inline bool elm::gesture_layer::attach(::evas::object target_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_gesture_layer_attach(::efl::eolian::to_c(target_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::gesture_layer::cb_del(Elm_Gesture_Type idx_, Elm_Gesture_State cb_type_, Elm_Gesture_Event_Cb cb_, void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gesture_layer_cb_del(idx_, cb_type_, cb_, data_));
}

inline void elm::gesture_layer::cb_add(Elm_Gesture_Type idx_, Elm_Gesture_State cb_type_, Elm_Gesture_Event_Cb cb_, void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gesture_layer_cb_add(idx_, cb_type_, cb_, data_));
}

inline double elm::gesture_layer::zoom_step_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_gesture_layer_zoom_step_get());
   return _tmp_ret;
}

inline void elm::gesture_layer::zoom_step_set(double step_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gesture_layer_zoom_step_set(step_));
}

inline Evas_Coord elm::gesture_layer::tap_finger_size_get() const
{
   Evas_Coord _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_gesture_layer_tap_finger_size_get());
   return _tmp_ret;
}

inline void elm::gesture_layer::tap_finger_size_set(Evas_Coord sz_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gesture_layer_tap_finger_size_set(sz_));
}

inline bool elm::gesture_layer::hold_events_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_gesture_layer_hold_events_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::gesture_layer::hold_events_set(bool hold_events_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gesture_layer_hold_events_set(::efl::eolian::to_c(hold_events_)));
}

inline double elm::gesture_layer::rotate_step_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_gesture_layer_rotate_step_get());
   return _tmp_ret;
}

inline void elm::gesture_layer::rotate_step_set(double step_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gesture_layer_rotate_step_set(step_));
}

inline void elm::gesture_layer::cb_set(Elm_Gesture_Type idx_, Elm_Gesture_State cb_type_, Elm_Gesture_Event_Cb cb_, void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gesture_layer_cb_set(idx_, cb_type_, cb_, data_));
}

inline bool eo_cxx::elm::gesture_layer::attach(::evas::object target_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_gesture_layer_attach(::efl::eolian::to_c(target_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::gesture_layer::cb_del(Elm_Gesture_Type idx_, Elm_Gesture_State cb_type_, Elm_Gesture_Event_Cb cb_, void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gesture_layer_cb_del(idx_, cb_type_, cb_, data_));
}

inline void eo_cxx::elm::gesture_layer::cb_add(Elm_Gesture_Type idx_, Elm_Gesture_State cb_type_, Elm_Gesture_Event_Cb cb_, void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gesture_layer_cb_add(idx_, cb_type_, cb_, data_));
}

inline double eo_cxx::elm::gesture_layer::zoom_step_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_gesture_layer_zoom_step_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::gesture_layer::zoom_step_set(double step_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gesture_layer_zoom_step_set(step_));
}

inline Evas_Coord eo_cxx::elm::gesture_layer::tap_finger_size_get() const
{
   Evas_Coord _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_gesture_layer_tap_finger_size_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::gesture_layer::tap_finger_size_set(Evas_Coord sz_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gesture_layer_tap_finger_size_set(sz_));
}

inline bool eo_cxx::elm::gesture_layer::hold_events_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_gesture_layer_hold_events_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::gesture_layer::hold_events_set(bool hold_events_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gesture_layer_hold_events_set(::efl::eolian::to_c(hold_events_)));
}

inline double eo_cxx::elm::gesture_layer::rotate_step_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_gesture_layer_rotate_step_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::gesture_layer::rotate_step_set(double step_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gesture_layer_rotate_step_set(step_));
}

inline void eo_cxx::elm::gesture_layer::cb_set(Elm_Gesture_Type idx_, Elm_Gesture_State cb_type_, Elm_Gesture_Event_Cb cb_, void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gesture_layer_cb_set(idx_, cb_type_, cb_, data_));
}

inline ::eo_cxx::elm::gesture_layer::operator ::elm::gesture_layer() const
{
   return *static_cast<::elm::gesture_layer const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::gesture_layer::operator ::elm::gesture_layer&()
{
   return *static_cast<::elm::gesture_layer*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::gesture_layer::operator ::elm::gesture_layer const&() const
{
   return *static_cast<::elm::gesture_layer const*>(static_cast<void const*>(this));
}

template <typename T>
bool elm_gesture_layer_attach_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Object * target_)
{
   try
      {
         return static_cast<T*>(self->this_)->attach(::efl::eolian::to_cxx<::evas::object>(target_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_gesture_layer_cb_del_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Gesture_Type idx_, Elm_Gesture_State cb_type_, Elm_Gesture_Event_Cb cb_, void * data_)
{
   try
      {
         static_cast<T*>(self->this_)->cb_del(idx_, cb_type_, cb_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_gesture_layer_cb_add_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Gesture_Type idx_, Elm_Gesture_State cb_type_, Elm_Gesture_Event_Cb cb_, void * data_)
{
   try
      {
         static_cast<T*>(self->this_)->cb_add(idx_, cb_type_, cb_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
double elm_gesture_layer_zoom_step_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->zoom_step_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         double _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_gesture_layer_zoom_step_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double step_)
{
   try
      {
         static_cast<T*>(self->this_)->zoom_step_set(step_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Evas_Coord elm_gesture_layer_tap_finger_size_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->tap_finger_size_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Evas_Coord _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_gesture_layer_tap_finger_size_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Coord sz_)
{
   try
      {
         static_cast<T*>(self->this_)->tap_finger_size_set(sz_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_gesture_layer_hold_events_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->hold_events_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_gesture_layer_hold_events_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool hold_events_)
{
   try
      {
         static_cast<T*>(self->this_)->hold_events_set(::efl::eolian::to_cxx<bool>(hold_events_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
double elm_gesture_layer_rotate_step_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->rotate_step_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         double _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_gesture_layer_rotate_step_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double step_)
{
   try
      {
         static_cast<T*>(self->this_)->rotate_step_set(step_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_gesture_layer_cb_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Gesture_Type idx_, Elm_Gesture_State cb_type_, Elm_Gesture_Event_Cb cb_, void * data_)
{
   try
      {
         static_cast<T*>(self->this_)->cb_set(idx_, cb_type_, cb_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::gesture_layer >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::widget >::template type<T>
   {
      virtual bool attach(::evas::object target_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_gesture_layer_attach(::efl::eolian::to_c(target_)));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void cb_del(Elm_Gesture_Type idx_, Elm_Gesture_State cb_type_, Elm_Gesture_Event_Cb cb_, void * data_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_gesture_layer_cb_del(idx_, cb_type_, cb_, data_));
      }

      virtual void cb_add(Elm_Gesture_Type idx_, Elm_Gesture_State cb_type_, Elm_Gesture_Event_Cb cb_, void * data_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_gesture_layer_cb_add(idx_, cb_type_, cb_, data_));
      }

      virtual double zoom_step_get()
      {
         double _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_gesture_layer_zoom_step_get());
            return _tmp_ret;
      }

      virtual void zoom_step_set(double step_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_gesture_layer_zoom_step_set(step_));
      }

      virtual Evas_Coord tap_finger_size_get()
      {
         Evas_Coord _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_gesture_layer_tap_finger_size_get());
            return _tmp_ret;
      }

      virtual void tap_finger_size_set(Evas_Coord sz_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_gesture_layer_tap_finger_size_set(sz_));
      }

      virtual bool hold_events_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_gesture_layer_hold_events_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void hold_events_set(bool hold_events_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_gesture_layer_hold_events_set(::efl::eolian::to_c(hold_events_)));
      }

      virtual double rotate_step_get()
      {
         double _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_gesture_layer_rotate_step_get());
            return _tmp_ret;
      }

      virtual void rotate_step_set(double step_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_gesture_layer_rotate_step_set(step_));
      }

      virtual void cb_set(Elm_Gesture_Type idx_, Elm_Gesture_State cb_type_, Elm_Gesture_Event_Cb cb_, void * data_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_gesture_layer_cb_set(idx_, cb_type_, cb_, data_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::gesture_layer >
{
   static constexpr int value = 
#if defined(GESTURE_LAYER_PROTECTED) && defined(GESTURE_LAYER_BETA)
      12
#elif defined(GESTURE_LAYER_PROTECTED)
      12
#elif defined(GESTURE_LAYER_BETA)
      12
#else
      12
#endif
      + operation_description_class_size<::elm::widget >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::gesture_layer>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_gesture_layer_attach_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gesture_layer_attach);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_gesture_layer_cb_del_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gesture_layer_cb_del);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_gesture_layer_cb_add_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gesture_layer_cb_add);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_gesture_layer_zoom_step_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gesture_layer_zoom_step_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_gesture_layer_zoom_step_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gesture_layer_zoom_step_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_gesture_layer_tap_finger_size_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gesture_layer_tap_finger_size_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_gesture_layer_tap_finger_size_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gesture_layer_tap_finger_size_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_gesture_layer_hold_events_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gesture_layer_hold_events_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_gesture_layer_hold_events_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gesture_layer_hold_events_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_gesture_layer_rotate_step_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gesture_layer_rotate_step_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_gesture_layer_rotate_step_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gesture_layer_rotate_step_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_gesture_layer_cb_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gesture_layer_cb_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::widget>(), &ops[operation_description_class_size< ::elm::gesture_layer >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::gesture_layer>)
{
   return (ELM_GESTURE_LAYER_CLASS);
}

} } }

/// @endcond

